#ifndef _LUA_H_
#define _LUA_H_

#include "trap.h"
#include "states.h"

#define RESULT_CONTINUE 0
#define RESULT_STOP_HANDLING (1 << 0)
#define RESULT_IGNORE_RESULT (1 << 1)

/**
 * runs a handler.
 * returns either RESULT_CONTINUE (0), or a bitmask of
 * RESULT_STOP_HANDLING, in which case we may not proceed with the
 * next handler and RESULT_IGNORE_RESULT, in which case we must ignore
 * this result.
 */
int run_handler(proc_trap *trap, proc_handler *handler, proc_result **result);

/**
 * purely a debugging method for when you don't understand what the stack is
 * doing.
 */
void dump_stack(lua_State *L);
#endif
